package de.desy.web2cToolkit.web2cArchive.web2cArchiveAccess;

import de.desy.web2cToolkit.web2cUtil.web2cDebug.Web2cFileLogger;
import de.desy.web2cToolkit.web2cUtil.web2cDebug.Web2cKeyBoardListener;
import de.desy.web2cToolkit.web2cUtil.web2cInterfaces.IWeb2cConstants;

/**
 * @author R.Bacher, DESY
 */
public class Web2cCommonArchiveAccess implements IWeb2cConstants {
	
	private Web2cTINEArchiveAccess web2cTINEArchive = null;	
	private Web2cDOOCSArchiveAcess web2cDOOCSArchive = null;
	private String ret = null;
	private String protocol = null;
	private String address = null;
	private Web2cFileLogger debugLogger = null;
	private Web2cKeyBoardListener debugFlagListener = null;

	/**
	 * Common archive access
	 * @param logger debug logger
	 */
	public Web2cCommonArchiveAccess(Web2cKeyBoardListener listener, Web2cFileLogger logger) {
		
		web2cTINEArchive = new Web2cTINEArchiveAccess();
		web2cDOOCSArchive = new Web2cDOOCSArchiveAcess();
		debugFlagListener = listener;
		debugLogger = logger;
	}
	
	public String getArchiveData(String property) {
		
		protocol = property.split("://")[0];
		address = property.split("://")[1];
		
		if (protocol.equals("tine")) {
			ret = web2cTINEArchive.getArchiveData(address);
		}		
		if (protocol.equals("doocs")) {
			ret = web2cDOOCSArchive.getArchiveData(address);
		}
	    if (debugFlagListener.getDebugControlSystemCommunication()) debugLogger.appendLog("from property " + property + ": " + ret);
	    
		return ret;
	}
}
