package de.desy.web2cToolkit.web2cUtil.web2cDebug;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Calendar;

/**
 * @author R.Bacher, DESY
 */
public class Web2cFileLogger{

	private File logFile = null;
	private boolean withTimeStamp = true;
	
	/**
	 * File Logger
	 * @param file log file
	 * @param timeStamp time Stamp flag (with / without)
	 */
	public Web2cFileLogger(File file, boolean timeStamp) {
		
		logFile = file;		
		withTimeStamp = timeStamp;
	}
	
	/**
	 * Appends log message to file
	 * @param logMessage log message
	 */
	public void appendLog(String logMessage) {

		BufferedWriter out = null;
		Calendar calendar = Calendar.getInstance(); 
		
		try {	
			if (out == null) {
				out = new BufferedWriter(new FileWriter(logFile.getCanonicalFile(), true));
			}
			if (withTimeStamp) {
				out.write(calendar.getTime().toString() + " " + logMessage);
			}
			else {
				out.write(logMessage);
			}
			out.newLine();
			out.flush();
			out.close();
		} catch (IOException e) {
			System.out.println("Error accessing log file " + logFile);
		}
	}
}
