package de.desy.web2cToolkit.web2cUtil.web2cFileIO;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;

import de.desy.web2cToolkit.web2cUtil.web2cDebug.Web2cFileLogger;
import de.desy.web2cToolkit.web2cUtil.web2cDebug.Web2cKeyBoardListener;
import de.desy.web2cToolkit.web2cUtil.web2cInterfaces.IWeb2cConstants;

/**
 * @author R.Bacher, DESY
 */
public class Web2cJavascriptWriter implements IWeb2cConstants {

	private File javascriptFile = null;
	private ArrayList<String> javascript = null;
	private Web2cFileLogger debugLogger = null;
	private Web2cKeyBoardListener debugListener = null;

	/**
	 * Writer for JavaScript File
	 * @param file name of page configuration file
	 * @param logger debug logger
	 * @param listener debug listener
	 */
	public Web2cJavascriptWriter(File file, Web2cFileLogger logger, Web2cKeyBoardListener listener) {
		
		javascriptFile = file;
		debugLogger = logger;
		debugListener = listener;
	}
	
	/**
	 * Writes JavaScript File (js-type)
	 */
	public void setJavascript(ArrayList<String> script) {
		
		javascript = new ArrayList<String>();
		javascript = script;
		
	    for (int i = 0; i < javascript.size(); i++) {
	    	if (debugListener.getDebugConfigurationFileParsing()) debugLogger.appendLog(javascript.get(i));
	    }
	    
	    try {
	    	BufferedWriter out = new BufferedWriter(new FileWriter(javascriptFile.getCanonicalFile()));
			for (Iterator<String> it = javascript.iterator(); it.hasNext();) {
				out.write((String)(it.next()));
				out.newLine();
			}
			out.flush();
			out.close();
		} catch (IOException e) {
			System.out.println("Error accessing javascript file");
		}
	}
}
