package de.desy.web2cToolkit.web2cUtil.web2cFileIO;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import java.util.Iterator;

/**
 * @author R.Bacher, DESY
 */
public class Web2cRegistryReader {
	
	private File userRegistryFile = null;
	private ArrayList<String> name = null;
	private ArrayList<String> password= null;

	/**
	 * Reader for Registry File 
	 * @param file name of registry file
	 */
	public Web2cRegistryReader(File file) {
		
		userRegistryFile = file;
		name = new ArrayList<String>();
		password = new ArrayList<String>();
		parseRegistry();
	}
	
	/**
	 * Returns the password of the user
	 * @param userName user name
	 * @return password
	 */
	public String getPassword(String userName) {
		
		String userPassword = null;
		
		Iterator<String> it2 = password.iterator();
		for (Iterator<String> it1 = name.iterator(); it1.hasNext();) {
			String str = (String)(it2.next());
			if (((String)(it1.next())).equals(userName)) {
				userPassword = str;
			}
		}
		
		return userPassword;
	}
	
	@SuppressWarnings("unchecked")
	private void parseRegistry() {
		
	   	SAXBuilder builder = null;
    	Document userRegistry = null;
    	Element registry = null;
    	List<Element> userList = null;
    	Element user = null;
    	List<Element> userAttributes = null;
    	Element userAttribute = null;

		builder = new SAXBuilder();
		try {
			userRegistry = builder.build(userRegistryFile);
		} catch (JDOMException e) {
			System.out.println("Error parsing user registry file.");
		} catch (IOException e) {
			System.out.println("Error reading user registry file.");
		}
		
		registry = userRegistry.getRootElement();
		userList = (List<Element>)registry.getChildren();   
		for (Iterator<Element> it1 = userList.iterator(); it1.hasNext();) {
			user = (Element)it1.next();  
			userAttributes = user.getChildren();
			for (Iterator<Element> it2 = userAttributes.iterator(); it2.hasNext();) {
				userAttribute = (Element)it2.next();  
				if ((userAttribute.getName()).equals("name")) {
					name.add(userAttribute.getValue());
				} 
				else if ((userAttribute.getName()).equals("password")) {
					password.add(userAttribute.getValue());
				}
			}
		}
	}
}
