package de.desy.web2cToolkit.web2cUtil.web2cInterfaces;

import java.util.ArrayList;

public interface IWeb2cComponent {

	/**
	 * Returns component's HTML tags 
	 * (Override, if applicable)
	 * @return HTML tags
	 */
	public ArrayList<String> getHTML();
	
	/**
	 * Returns component's JavaScript code snippets
	 * (Override, if applicable)
	 * @return JavaScript code snippets
	 */
	public ArrayList<String> getJavaScript();
	
	/**
	 * Returns real data from common device access plug
	 * (Override, if applicable)
	 * @return data (xml-type)
	 */
	public String getRealData();
	
	/**
	 * Returns simulated data
	 * (Override, if applicable)
	 * @return data (xml-type)
	 */
	public String getSimulatedData();
}
