package de.desy.web2cToolkit.web2cUtil.web2cInterfaces;

import java.io.ByteArrayOutputStream;

public interface IWeb2cVideoClient {
	
	/**
    * Closes the receiver for the url requested
    * @param url url
    */
    public void closeReceiver(String url);
	
    /**
     * Connects to video source
     * @param url url
     */
    public void connectToVideoSource(String url);
    
	/**
 	 * Assigns the frame of the url requested to the output stream
 	 * @param frame output stream
	 * @param url url
	 */
    public void getVideo(ByteArrayOutputStream frame, String url);
    
	/**
	 * Returns error string for the url specified
	 * @param url url
	 * @return error string
	 */
    public String getError(String url);

	/**
	 * Returns description for the url specified
	 * @param url url
	 * @return description
	 */
    public String getDescription(String url);
}
