package test;

import javax.swing.SwingUtilities;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JButton;
import java.awt.Rectangle;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Calendar;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.methods.PostMethod;

public class GatewayTest extends JFrame {

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JButton registerButton = null;
	private JButton updateButton = null;
	private JButton executeButton = null;
	private JButton logoutButton = null;
	private JTextArea returnDataArea = null;
	private JTextField registerField = null;
	private JTextField updateField = null;
	private JTextField executeField = null;
	private JButton searchButton = null;
	private JButton loginExpertButton = null;
	private JButton loginGuest = null;
	static private String username = "";  //  @jve:decl-index=0:
	static private String password = "";  //  @jve:decl-index=0:
	private String logoutURL = "";  //  @jve:decl-index=0:
	private String registerURL = "";  //  @jve:decl-index=0:
	private String executeURL = "";  //  @jve:decl-index=0:
	private String updateURL = "";  //  @jve:decl-index=0:
	private JButton pollButton = null;
	private JTextField pollField = null;
	private String pollInterval = "1000";
	private JButton stopPollButton = null;
	private PollTimer pollTimer = null;

	/**
	 * This method initializes registerButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getRegisterButton() {
		
		if (registerButton == null) {
			try {
				registerButton = new JButton();
				registerButton.setBounds(new Rectangle(45, 31, 121, 47));  // Generated
				registerButton.setText("Register");  // Generated
				registerButton.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
					    HttpClient client = new HttpClient();
					    client.getParams().setParameter("http.useragent", "Web2cGateway Test Client");
					    BufferedReader br = null;
					    PostMethod method = new PostMethod("http://localhost:8080/web2cToolkit/Web2cGateway");
					    method.addParameter("param", "<action>" + registerField.getText() + "<timeStamp>" + String.valueOf(Calendar.getInstance().getTimeInMillis()) + "</timeStamp></action>");					    
			            String readLine = "";
						try {
					    	int returnCode = client.executeMethod(method);
					        if (returnCode == HttpStatus.SC_NOT_IMPLEMENTED) {
					    	    System.err.println("The Post method is not implemented by this URI");
					            method.getResponseBodyAsString();
					        } 
					        else {
					    	    br = new BufferedReader(new InputStreamReader(method.getResponseBodyAsStream()));
					            while(((readLine = br.readLine()) != null)) {
//					        	    System.err.println(readLine);
					        	    returnDataArea.setText(readLine);
					            }
					        }
					    } 
					    catch (Exception ex) {
					    	System.err.println(ex);
					    } 
					    finally {
					    	method.releaseConnection();
					    	if(br != null) try { br.close(); } catch (Exception fe) {}
					    }
					}
				});
			} catch (java.lang.Throwable e) {}
		}
		return registerButton;
	}

	/**
	 * This method initializes updateButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getUpdateButton() {
		if (updateButton == null) {
			try {
				updateButton = new JButton();
				updateButton.setBounds(new Rectangle(45, 90, 122, 47));  // Generated
				updateButton.setText("Single Update");  // Generated
				updateButton.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						String data = "";
						Calendar calendar1 = Calendar.getInstance();
						long start = calendar1.getTimeInMillis();
					    HttpClient client = new HttpClient();
					    client.getParams().setParameter("http.useragent", "Web2cGateway Test Client");
					    BufferedReader br = null;
					    PostMethod method = new PostMethod("http://localhost:8080/web2cToolkit/Web2cGateway");
					    method.addParameter("param", "<action>" + updateField.getText() + "<timeStamp>" + String.valueOf(Calendar.getInstance().getTimeInMillis()) + "</timeStamp></action>");
					    try {
					    	int returnCode = client.executeMethod(method);
					        if (returnCode == HttpStatus.SC_NOT_IMPLEMENTED) {
					    	    System.err.println("The Post method is not implemented by this URI");
					            method.getResponseBodyAsString();
					        } 
					        else {
					    	    br = new BufferedReader(new InputStreamReader(method.getResponseBodyAsStream()));
					            String readLine;
					            while(((readLine = br.readLine()) != null)) {
//					        	    System.err.println(readLine);
					            	data = readLine;
					            }
					        }
					    } 
					    catch (Exception ex) {
					    	System.err.println(ex);
					    } 
					    finally {
					    	method.releaseConnection();
					    	if(br != null) try { br.close(); } catch (Exception fe) {}
					    }
						Calendar calendar2 = Calendar.getInstance();
						long stop = calendar2.getTimeInMillis();
		        	    returnDataArea.setText("TransactionTime: " + (stop - start) + " Data: " + data);
					}
				});
			} catch (java.lang.Throwable e) {}
		}
		return updateButton;
	}

	/**
	 * This method initializes executeButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getExecuteButton() {
		if (executeButton == null) {
			try {
				executeButton = new JButton();
				executeButton.setBounds(new Rectangle(45, 149, 123, 47));  // Generated
				executeButton.setText("Execute");  // Generated
				executeButton.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
					    HttpClient client = new HttpClient();
					    client.getParams().setParameter("http.useragent", "Web2cGateway Test Client");
					    BufferedReader br = null;
					    PostMethod method = new PostMethod("http://localhost:8080/web2cToolkit/Web2cGateway");
					    method.addParameter("param", "<action>" + executeField.getText() + "<timeStamp>" + String.valueOf(Calendar.getInstance().getTimeInMillis()) + "</timeStamp></action>");
					    try {
					    	int returnCode = client.executeMethod(method);
					        if (returnCode == HttpStatus.SC_NOT_IMPLEMENTED) {
					    	    System.err.println("The Post method is not implemented by this URI");
					            method.getResponseBodyAsString();
					        } 
					        else {
					    	    br = new BufferedReader(new InputStreamReader(method.getResponseBodyAsStream()));
					            String readLine;
					            while(((readLine = br.readLine()) != null)) {
//					        	    System.err.println(readLine);
					        	    returnDataArea.setText(readLine);
					            }
					        }
					    } 
					    catch (Exception ex) {
					    	System.err.println(ex);
					    } 
					    finally {
					    	method.releaseConnection();
					    	if(br != null) try { br.close(); } catch (Exception fe) {}
					    }
					}
				});
			} catch (java.lang.Throwable e) {}
		}
		return executeButton;
	}

	/**
	 * This method initializes logoutButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getLogoutButton() {
		if (logoutButton == null) {
			try {
				logoutButton = new JButton();
				logoutButton.setBounds(new Rectangle(959, 211, 122, 48));  // Generated
				logoutButton.setText("Logout");  // Generated
				logoutButton.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
					    HttpClient client = new HttpClient();
					    client.getParams().setParameter("http.useragent", "Web2cGateway Test Client");
					    BufferedReader br = null;
					    PostMethod method = new PostMethod("http://localhost:8080/web2cToolkit/Web2cGateway");
					    method.addParameter("param", "<action>" + logoutURL + "<timeStamp>" + String.valueOf(Calendar.getInstance().getTimeInMillis()) + "</timeStamp></action>");
					    try {
					    	int returnCode = client.executeMethod(method);
					        if (returnCode == HttpStatus.SC_NOT_IMPLEMENTED) {
					    	    System.err.println("The Post method is not implemented by this URI");
					            method.getResponseBodyAsString();
					        } 
					        else {
					    	    br = new BufferedReader(new InputStreamReader(method.getResponseBodyAsStream()));
					            String readLine;
					            while(((readLine = br.readLine()) != null)) {
//					        	    System.err.println(readLine);
					        	    returnDataArea.setText(readLine);
					            }
					        }
					    } 
					    catch (Exception ex) {
					    	System.err.println(ex);
					    } 
					    finally {
					    	method.releaseConnection();
					    	if(br != null) try { br.close(); } catch (Exception fe) {}
					    }
					}
				});
			} catch (java.lang.Throwable e) {}
		}
		return logoutButton;
	}

	/**
	 * This method initializes returnDataArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getReturnDataArea() {
		if (returnDataArea == null) {
			try {
				returnDataArea = new JTextArea();
				returnDataArea.setBounds(new Rectangle(45, 268, 1045, 301));  // Generated
				returnDataArea.setLineWrap(true);  // Generated
				returnDataArea.setColumns(10);  // Generated
				returnDataArea.setWrapStyleWord(true);  // Generated
			} catch (java.lang.Throwable e) {}
		}
		return returnDataArea;
	}

	/**
	 * This method initializes registerField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getRegisterField() {
		if (registerField == null) {
			try {
				registerField = new JTextField();
				registerField.setBounds(new Rectangle(180, 31, 909, 49));  // Generated
			} catch (java.lang.Throwable e) {}
		}
		return registerField;
	}

	/**
	 * This method initializes updateField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getUpdateField() {
		if (updateField == null) {
			try {
				updateField = new JTextField();
				updateField.setBounds(new Rectangle(180, 90, 910, 48));  // Generated
			} catch (java.lang.Throwable e) {}
		}
		return updateField;
	}

	/**
	 * This method initializes executeField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getExecuteField() {
		if (executeField == null) {
			try {
				executeField = new JTextField();
				executeField.setBounds(new Rectangle(180, 150, 912, 46));  // Generated
			} catch (java.lang.Throwable e) {}
		}
		return executeField;
	}

	/**
	 * This method initializes searchButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSearchButton() {
		if (searchButton == null) {
			try {
				searchButton = new JButton();
				searchButton.setBounds(new Rectangle(509, 213, 125, 45));  // Generated
				searchButton.setText("CheckAlive");  // Generated
				searchButton.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
					    HttpClient client = new HttpClient();
					    client.getParams().setParameter("http.useragent", "Web2cGateway Test Client");
					    BufferedReader br = null;
					    PostMethod method = new PostMethod("http://localhost:8080/web2cToolkit/Web2cGateway");
					    method.addParameter("param", "checkAlive");
					    try {
					    	int returnCode = client.executeMethod(method);
					        if (returnCode == HttpStatus.SC_NOT_IMPLEMENTED) {
					    	    System.err.println("The Post method is not implemented by this URI");
					            method.getResponseBodyAsString();
					        } 
					        else {
					    	    br = new BufferedReader(new InputStreamReader(method.getResponseBodyAsStream()));
					            String readLine;
					            while(((readLine = br.readLine()) != null)) {
//					        	    System.err.println(readLine);
					        	    returnDataArea.setText(readLine);
					            }
					        }
					    } 
					    catch (Exception ex) {
					    	System.err.println(ex);
					    } 
					    finally {
					    	method.releaseConnection();
					    	if(br != null) try { br.close(); } catch (Exception fe) {}
					    }
					}
				});
			} catch (java.lang.Throwable e) {}
		}
		return searchButton;
	}

	/**
	 * This method initializes loginExpertButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getLoginExpertButton() {
		if (loginExpertButton == null) {
			try {
				loginExpertButton = new JButton();
				loginExpertButton.setBounds(new Rectangle(685, 212, 125, 46));  // Generated
				loginExpertButton.setText("LoginExpert");  // Generated
				loginExpertButton.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						String key = "";
						String loginURL = "";
					    HttpClient client = new HttpClient();
					    client.getParams().setParameter("http.useragent", "Web2cGateway Test Client");
					    BufferedReader br = null;
					    PostMethod method = new PostMethod("http://localhost:8080/web2cToolkit/Web2cGateway");
					    method.addParameter("param", "loginExpert");
					    try {
					    	int returnCode = client.executeMethod(method);
					        if (returnCode == HttpStatus.SC_NOT_IMPLEMENTED) {
					    	    System.err.println("The Post method is not implemented by this URI");
					            method.getResponseBodyAsString();
					        } 
					        else {
					    	    br = new BufferedReader(new InputStreamReader(method.getResponseBodyAsStream()));
					            String readLine;
					            while(((readLine = br.readLine()) != null)) {
//					        	    System.err.println(readLine);
					        	    returnDataArea.setText(readLine);
					        	    key = readLine.split("</key>")[0].replace("<return><key>", "");
					        	    MD5HashGenerator md5 = new MD5HashGenerator(password + key);
					        	    loginURL = readLine.split("</sessionId><loginURL>")[1].split("<userName>")[0];
					        	    loginURL = loginURL + "<userName>" + username + "</userName><password>" + md5.getMD5() + "</password>";
					            }
					        }
					    } 
					    catch (Exception ex) {
					    	System.err.println(ex);
					    } 
					    finally {
					    	method.releaseConnection();
					    	if(br != null) try { br.close(); } catch (Exception fe) {}
					    }
					    
					    client = new HttpClient();
					    client.getParams().setParameter("http.useragent", "Web2cGateway Test Client");
					    br = null;
					    method = new PostMethod("http://localhost:8080/web2cToolkit/Web2cGateway");
					    method.addParameter("param", loginURL + "<timeStamp>" + String.valueOf(Calendar.getInstance().getTimeInMillis()) + "</timeStamp></elogin>");
					    try {
					    	int returnCode = client.executeMethod(method);
					        if (returnCode == HttpStatus.SC_NOT_IMPLEMENTED) {
					    	    System.err.println("The Post method is not implemented by this URI");
					            method.getResponseBodyAsString();
					        } 
					        else {
					    	    br = new BufferedReader(new InputStreamReader(method.getResponseBodyAsStream()));
					            String readLine;
					            while(((readLine = br.readLine()) != null)) {
//					        	    System.err.println(readLine);
					        	    returnDataArea.setText(readLine);
					        	    logoutURL = readLine.split("<logoutURL><action>")[1].split("</value>")[0] + "</value>";
					        	    registerURL = readLine.split("<registerURL><action>")[1].split("</value>")[0] + "</value>";
					        	    registerField.setText(registerURL);
					        	    executeURL = readLine.split("<executeURL><action>")[1].split("</value>")[0] + "</value>";
					        	    executeField.setText(executeURL);
					        	    updateURL = readLine.split("<updateURL><action>")[1].split("</value>")[0] + "</value>";
					        	    updateField.setText(updateURL);
					            }
					        }
					    } 
					    catch (Exception ex) {
					    	System.err.println(ex);
					    } 
					    finally {
					    	method.releaseConnection();
					    	if(br != null) try { br.close(); } catch (Exception fe) {}
					    }
					}
				});
			} catch (java.lang.Throwable e) {}
		}
		return loginExpertButton;
	}

	/**
	 * This method initializes loginGuest	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getLoginGuest() {
		if (loginGuest == null) {
			try {
				loginGuest = new JButton();
				loginGuest.setBounds(new Rectangle(821, 211, 126, 47));  // Generated
				loginGuest.setText("LoginGuest");  // Generated
				loginGuest.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
					    HttpClient client = new HttpClient();
					    client.getParams().setParameter("http.useragent", "Web2cGateway Test Client");
					    BufferedReader br = null;
					    PostMethod method = new PostMethod("http://localhost:8080/web2cToolkit/Web2cGateway");
					    method.addParameter("param", "loginGuest");
					    try {
					    	int returnCode = client.executeMethod(method);
					        if (returnCode == HttpStatus.SC_NOT_IMPLEMENTED) {
					    	    System.err.println("The Post method is not implemented by this URI");
					            method.getResponseBodyAsString();
					        } 
					        else {
					    	    br = new BufferedReader(new InputStreamReader(method.getResponseBodyAsStream()));
					            String readLine;
					            while(((readLine = br.readLine()) != null)) {
//					        	    System.err.println(readLine);
					        	    returnDataArea.setText(readLine);
					        	    logoutURL = readLine.split("<logoutURL><action>")[1].split("</value>")[0] + "</value>";
					        	    registerURL = readLine.split("<registerURL><action>")[1].split("</value>")[0] + "</value>";
					        	    registerField.setText(registerURL);
					        	    executeURL = readLine.split("<executeURL><action>")[1].split("</value>")[0] + "</value>";
					        	    executeField.setText(executeURL);
					        	    updateURL = readLine.split("<updateURL><action>")[1].split("</value>")[0] + "</value>";
					        	    updateField.setText(updateURL);
					            }
					        }
					    } 
					    catch (Exception ex) {
					    	System.err.println(ex);
					    } 
					    finally {
					    	method.releaseConnection();
					    	if(br != null) try { br.close(); } catch (Exception fe) {}
					    }
					}
				});
			} catch (java.lang.Throwable e) {}
		}
		return loginGuest;
	}

	/**
	 * This method initializes pollButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getPollButton() {
		if (pollButton == null) {
			try {
				pollButton = new JButton();
				pollButton.setBounds(new Rectangle(45, 210, 123, 47));  // Generated
				pollButton.setText("Start Update");  // Generated
				pollButton.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						pollTimer.startTimer();
					}
				});
			} catch (java.lang.Throwable e) {}
		}
		return pollButton;
	}

	/**
	 * This method initializes pollField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPollField() {
		if (pollField == null) {
			try {
				pollField = new JTextField();
				pollField.setBounds(new Rectangle(181, 211, 125, 46));  // Generated
				pollField.setText("");  // Generated
			} catch (java.lang.Throwable e) {}
		}
		return pollField;
	}

	/**
	 * This method initializes stopPollButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getStopPollButton() {
		if (stopPollButton == null) {
			try {
				stopPollButton = new JButton();
				stopPollButton.setBounds(new Rectangle(330, 212, 124, 44));  // Generated
				stopPollButton.setText("Stop Update");  // Generated
				stopPollButton.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						pollTimer.stopTimer();
					}
				});
			} catch (java.lang.Throwable e) {}
		}
		return stopPollButton;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		username = args[0];
		password = args[1];
		
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				GatewayTest thisClass = new GatewayTest();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}

	/**
	 * This is the default constructor
	 */
	public GatewayTest() {
		super();
		initialize();
		this.getPollField().setText(pollInterval);
		pollTimer = new PollTimer();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(1106, 617);
		this.setContentPane(getJContentPane());
		this.setTitle("Web2cGateway-Test");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getRegisterButton(), null);  // Generated
			jContentPane.add(getUpdateButton(), null);  // Generated
			jContentPane.add(getExecuteButton(), null);  // Generated
			jContentPane.add(getLogoutButton(), null);  // Generated
			jContentPane.add(getReturnDataArea(), null);  // Generated
			jContentPane.add(getRegisterField(), null);  // Generated
			jContentPane.add(getUpdateField(), null);  // Generated
			jContentPane.add(getExecuteField(), null);  // Generated
			jContentPane.add(getSearchButton(), null);  // Generated
			jContentPane.add(getLoginExpertButton(), null);  // Generated
			jContentPane.add(getLoginGuest(), null);  // Generated
			jContentPane.add(getPollButton(), null);  // Generated
			jContentPane.add(getPollField(), null);  // Generated
			jContentPane.add(getStopPollButton(), null);  // Generated
		}
		return jContentPane;
	}
	
	class PollTimer implements Runnable {
		
		Thread timer = null;
		boolean started = false;
		
		PollTimer() {
			timer = new Thread(this);
			started = false;
			timer.start();
		}
		
		public void startTimer() {
			started = true;
			pollInterval = pollField.getText();
		}
		
		public void stopTimer() {
			started = false;
		}

		public void run() {
			while (true) {
				try {
					if (started == true) {
			            String data = "";
						Calendar calendar1 = Calendar.getInstance();
						long start = calendar1.getTimeInMillis();
					    HttpClient client = new HttpClient();
					    client.getParams().setParameter("http.useragent", "Web2cGateway Test Client");
					    BufferedReader br = null;
					    PostMethod method = new PostMethod("http://localhost:8080/web2cToolkit/Web2cGateway");
					    method.addParameter("param", "<action>" + updateField.getText() + "<timeStamp>" + String.valueOf(Calendar.getInstance().getTimeInMillis()) + "</timeStamp></action>");
					    try {
					    	int returnCode = client.executeMethod(method);
					        if (returnCode == HttpStatus.SC_NOT_IMPLEMENTED) {
					    	    System.err.println("The Post method is not implemented by this URI");
					            method.getResponseBodyAsString();
					        } 
					        else {
					    	    br = new BufferedReader(new InputStreamReader(method.getResponseBodyAsStream()));
					            String readLine;
					            while(((readLine = br.readLine()) != null)) {
	//				        	    System.err.println(readLine);
					            	data = readLine;
					            }
					        }
					    } 
					    catch (Exception ex) {
					    	System.err.println(ex);
					    } 
					    finally {
					    	method.releaseConnection();
					    	if(br != null) try { br.close(); } catch (Exception fe) {}
					    }
						Calendar calendar2 = Calendar.getInstance();
						long stop = calendar2.getTimeInMillis();
		        	    returnDataArea.setText("TransactionTime: " + (stop - start) + " Data: " + data);
					}
					Thread.sleep(Integer.valueOf(pollInterval));
				}
				catch (InterruptedException e) {}
			}
		}
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
